/*
 sdltest.c
 by Michal Nostitz-Jackowski aka JaM/KoRoZone
 email: jam_krz@poczta.onet.pl
*/

#include <stdio.h>
#include <SDL/SDL.h>

SDL_Surface *surface;
long *pixels;
char *sdlkeys;
long i,j;
char r,g,b;

main()
{
 setbuf(stdout,NULL);

 if (SDL_Init(SDL_INIT_VIDEO) < 0)
  {
   printf("Blad podczas inicjowania SDL!\n"); return;
  }

 SDL_WM_SetCaption("SDL Test by JaM^KRz!",NULL);

 if(SDL_VideoModeOK(640,480,32,SDL_HWSURFACE|SDL_FULLSCREEN|SDL_DOUBLEBUF))
  surface=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_FULLSCREEN|SDL_DOUBLEBUF);

 if (surface==NULL)
  {
   printf("Blad podczas inicjowania trybu graficznego!\n"); SDL_Quit(); return;
  }

 pixels=surface->pixels;
 if(SDL_MUSTLOCK(surface)) SDL_LockSurface(surface);

 for( i=0; i<480; i++ )
  for( j=r=g=b=0; j<640; j++,r+=3,g+=2,b++ )
   pixels[i*(surface->pitch>>2)+j] = ((r^i)<<surface->format->Rshift)|
                                     ((g^i)<<surface->format->Gshift)|
                                     ((b^i)<<surface->format->Bshift);

 if(SDL_MUSTLOCK(surface)) SDL_UnlockSurface(surface);

 SDL_Flip(surface);

 SDL_PumpEvents();
 sdlkeys=SDL_GetKeyState(NULL);
 while(sdlkeys[SDLK_ESCAPE]!=SDL_PRESSED)
 {
  SDL_PumpEvents();
  sdlkeys=SDL_GetKeyState(NULL);
 }

 SDL_Quit();
}
